/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : EdgeGraph.cc                                             */
/*                                                                       */
/*       Date : November  2, 1997                                        */
/* Updated at : November  3, 1997                                        */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/


#include "EdgeGraph.h"
#include "gene.h"
#include "global.h"
#include <stdio.h>
#include <stdlib.h>


/*
//
*/

type_EdgeGraph* defineEdgeGraph(unsigned _size)
{

   int i,j;
   type_EdgeGraph* myGraph = (type_EdgeGraph*) calloc(1,sizeof(type_EdgeGraph));

   if(myGraph!=NULL)
   {
      float *myMatrix = (float *) calloc(_size*_size,sizeof(float));

      if(myMatrix!=NULL)
      {
         myGraph->myGenes = (type_Gene  *) calloc(_size,sizeof(type_Gene));

         if(myGraph->myGenes != NULL)
         { 
            myGraph->matrix = myMatrix;

            for(i=0;i<_size;i++)
               for(j=0;j<_size;j++) myGraph->matrix[i*_size+j] = -1.0;

            myGraph->cIndex = 0;
            myGraph->size = _size;
         }
         else
         { 
            free(myGraph);
            free(myMatrix);
            myGraph = NULL;
         }

      }
      else 
      { 
         free(myGraph);
         myGraph = NULL;
      }
      
   }

   return myGraph;

}// end of 

/*
//
*/

void addEdge(type_EdgeGraph *this, type_Gene gene)
{
    if(this->cIndex<this->size)
    {
	this->myGenes[this->cIndex] = gene;
	this->cIndex++;

    }// end of if

}// end of addEdge()

/*
//
*/

distance_t getCost(type_EdgeGraph *this, int from, int to) 
{
   distance_t retVal = 0;

   if(from>=0 && from<this->size && to>=0 && to <this->size)
   { 
      if(this->matrix[from*this->size+to]<0) 
         this->matrix[from*this->size+to] = 
                 calculateDistanceTo(&this->myGenes[from],&this->myGenes[to]);

      retVal = this->matrix[from*this->size+to];
   }

   return retVal;

}// end of getCost()

void disposeEdgeGraph(type_EdgeGraph *this)
{
    free(this->matrix);
    free(this->myGenes);
    free(this);
}
